unit CybExprtBase;
{checked 24/05/2000 BI}

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  editintf,
  ExptIntf, ToolIntf;

type

TCybExpertBaseClass = class(TIExpert)
 Private

 Protected

 Public
    procedure Insertext (astr : string);
    procedure ReplaceInclusive(EditIntf: TIEditorInterface; astr : string);


 Published

end;

implementation

procedure TCybExpertBaseClass.Insertext (astr : string);
var
  ModIntf: TIModuleInterface;
  EditIntf: TIEditorInterface;
  mc :integer;

begin
  if (astr = '') then exit;
  with ToolServices do ModIntf := GetModuleInterface(GetCurrentFile);
  if (ModIntf <> nil) then begin
    try
      EditIntf := ModIntf.GetEditorInterface;
      if EditIntf <> nil then begin
        try
          mc := pred(EditIntf.GetViewCount);
          if (mc > 0) then MessageDlg('Please close extra views',mtWarning,[mbOK],0);
          if (mc = 0) then begin
              ReplaceInclusive(EditIntf, astr);
          end;
        finally
          EditIntf.Free;
        end;
      end;
    finally
      ModIntf.Free;
    end;
  end;
end;

procedure TCybExpertBaseClass.ReplaceInclusive(EditIntf: TIEditorInterface; astr : string);
var
    Writer: TIEditWriter;
    StartPos : Integer;
View: TIEditView;
  cpos : teditpos;
  chpos : tcharpos;

begin
    View:=EditIntf.getview(0);
    cpos := View.cursorpos;
    View.convertpos(true, cpos, chpos);
    StartPos := View.CharPosToPos(chpos);
    Writer := EditIntf.CreateUndoableWriter;
    try
      { Copy the initial part of the file, up to the selection. }
      Writer.CopyTo(StartPos);
      { Delete the block if there is one to delete. }
      Writer.Insert(PChar(astr));
      { Copy the rest of the file. }
      Writer.CopyTo(High(LongInt));
    finally
      Writer.Free;
    end;
end;


end.


Constructor TCybExpertBaseClass.Create(aowner : tcomponent);

begin
  inherited create(aowner);

end;

Destructor TCybExpertBaseClass.Destroy;

begin

  inherited destroy;
end;

