unit Cybifile;
{checked 24/05/2000 BI}

interface

uses
{$ifdef tadlcompile}
  bstrfuncs,
{$endif}
  forms, graphics, dialogs, classes, sysutils;


const
       Bnum = 0;
       Inum = 1;
       Snum =2;
       Rnum =3;
       Pnum =4;
  opensq = '[';
  closesq = ']';
  objstr = 'object';
  leftstr = 'Left';
  eqstr = '=';
  sp = ' ';
  topstr = 'Top';
  widthstr = 'Width';
  heightstr = 'Height';
  endstr = 'End';
  tstr = ' : T';
  readstr = 'Read';
  writestr = 'Write';
  colonstr = ':';
  opencurl = '{';
  closecurl = '}';
  comstr = ',';
  stopstr = '.';
  truestr = 'True';
  falsestr = 'False';
  undstr = '_';
  paseqstr = ' := ';
  onestr = '1';
  zerostr = '0';
  Sepchar : char =',';
  semistr = ';';
  Ini_WLeft  = 'Left';
  Ini_WTop   = 'Top';
  Ini_WWidth = 'Width';
  Ini_WHeight= 'Height';
  Ini_Title = 'Title';

  fontstrucstr = 'S100,I,S25,B,B,B,B';

type

tfontstruc = record
 fontstrucName : string[100];
 fontstrucSize : longint;
 fontstrucColor : string[25];
 fontstrucBold : boolean;
 fontstrucItalic : boolean;
 fontstrucUnderline : boolean;
 fontstrucStrikeOut : boolean;
end;

sectcntrec = packed record
{$ifndef win32}
    BegNo, EndNo : integer;
{$else}
    BegNo, EndNo : smallint;
{$endif}
end;

valobj = class
    vstr : string;
end;

{initypes = (inistring, iniinteger, iniboolean, inireal, inicomp, iniunknown);}

tinifile = class(tpersistent)
private
  flist : tstringlist;
  fsectlist : tlist;
  fname : tfilename;
  fcursectname : string;
  fcursectindex : integer;
  fcurlinename : string;
  fcurlineindex : integer;
  fSectionNameList : tstringlist;
  fCurSectRec : sectcntrec;
  fExistingFile : boolean;   

  function sect_test(var sectstr : string) : boolean;
  procedure add_section( sname : string; beg, num : integer);
{  procedure change_section( sectno, begdelta, cntdelta : integer);}

   procedure sectnos(noptr  : pointer; var begval, endval : integer);
   function new_sect(begval, endval : integer) : pointer;
   Function GetSectionNameList : tstringlist;

   procedure readfile;
   procedure savefile;
   procedure setnullcursect;
   procedure setnullcurline;
protected

  function IsBoolean( valstr : string; var val : boolean) : Boolean;
  function IsInteger( valstr : string; var val : LongInt) : Boolean;
  function IsDouble( valstr : string; var val : Double) : Boolean;
  function IsPointer( valstr : string; var pstr : string; var size : integer; var val : Pointer) : Boolean;
  function IsString( valstr : string; var val : String) : Boolean;

public
   fmodified : boolean;

   constructor Create(afname : tfilename);
   destructor Destroy; override;
   function sect_exist(sname : string) : boolean;
   function ReadBool(const Section, Ident: string; Default: Boolean): Boolean;
   function ReadInteger(const Section, Ident: string; Default: Longint): Longint;
   function ReadDouble(const Section, Ident: string; Default: Double): Double;
   function ReadPointer(const Section, Ident: string; structstr : string): Pointer;
   function ReadString(const Section, Ident, Default: string): string;
   procedure EraseSection(const Section: string);
   procedure ReadSection (const Section: string; AStrings: TStrings);
   procedure ReadSectionValues(const Section: string; AStrings: TStrings);
   procedure ReadWholeSection (const Section: string; AStrings: TStrings);
   function ReadWholeSectionAsString (const Section: string ): string;

   function SectionCount(const Section: string): Longint;

   procedure ExchangeSection(const Section: string; aplist : tstrings);
   function  get_index( sname, lname : string) : integer;
   function  get_line( sname : string; lno : integer) : string;
   procedure WriteBool(const Section, Ident: string; Value: Boolean);
   procedure WriteInteger(const Section, Ident: string; Value: Longint);
   procedure WriteString(const Section, Ident, Value: string);
   procedure WriteDouble(const Section, Ident: string; Value: Double);
   procedure WritePointer(const Section, Ident: string; structstr : string; Value: Pointer);
   procedure ReadStringList(const Section, Ident : string; AStrings: TStrings);
   procedure WriteStringList(const Section, Ident : string; AStrings: TStrings);

   PROCEDURE writefont(const Section, Ident: string; afont : tfont);
   PROCEDURE readfont(const Section, Ident: string; afont: tfont);
   PROCEDURE writeform(aform : tform);
   PROCEDURE readform(aform : tform);

   PROCEDURE Flush;
   PROCEDURE refresh;

   procedure Erase_line(const Section, Ident: string);
   function has_value( instr : string; var ostr, vstr : string) : boolean;

   procedure resetfile;
   procedure renumber;
   procedure remove_empty;
   function ReadString2Pointer(tstr : string; structstr : string): Pointer;


   property FileName: tfilename read fname write fname;
   Property items : tstringlist read flist write flist;
   Property SectList : tlist Read fSectList Write fSectList;
   Property cursectrec  : sectcntrec Read fCurSectRec  Write fCurSectRec ;
   Property SectionNameList : tstringlist Read GetSectionNameList;
   Property ExistingFile : boolean Read fExistingFile Write fExistingFile;

end;

function show_val(valo : tobject) : string;
function new_val_obj(nval : string) : tobject;
procedure free_val_obj(valo : tobject);

procedure readstrlist(inifile : tinifile; aplist:  tstrings; Sectname : string);
procedure writestrlist(inifile : tinifile; aplist:  tstrings; Sectname : string);

procedure rescaleform(aform : tform);

var
  inifile : tinifile;
  runscale : integer;

const
  designscale = 120;

implementation
{$ifndef tadlcompile}
uses
cybmanip;
{$endif}

procedure readstrlist(inifile : tinifile; aplist:  tstrings; Sectname : string);
begin
    aplist.clear;
    inifile.readsection(Sectname, aplist);
end;

procedure writestrlist(inifile : tinifile; aplist:  tstrings; Sectname : string);
{var
  lc, mc : integer;
 }
begin
    inifile.exchangesection(Sectname, aplist);
{    for lc := 0 to mc do inifile.WriteString(Sectname,aplist[lc], '');}
end;

{type
  charset = set of char;

const
  boolchars : charset = ['T','R','U','E','F','A','L','S','Y','N','O','0','1'];
  numchars : charset =['0'..'9'];}

function new_val_obj(nval : string) : tobject;

begin
  if (nval <> '') then begin
    result := valobj.create;
    valobj(result).vstr := nval;
  end
  else result := nil;
end;

procedure free_val_obj(valo : tobject);

begin
  if assigned(valo) then valobj(valo).free;
  valo := nil;
end;

function show_val(valo : tobject) : string;

begin
  if assigned(valo) then result := valobj(valo).vstr
                     else result := '';
end;

function comment_test(instr : string) : boolean;
begin
{    result := (instr[1] = ';');}
    result := (pos(';',instr) = 1);
end;

function null_test(instr : string) : boolean;

begin
    result := (instr = ' ') or (instr = '');
end;


function tinifile.sect_test(var sectstr : string) : boolean;
var
  obpos,cbpos : integer;

begin
    result := false;
    if null_test(sectstr) or comment_test(sectstr) then exit;
    obpos := pos(opensq, sectstr);
    cbpos := pos(closesq, sectstr);
    result := (obpos <> 0) and (cbpos <> 0);
{    if result then sectstr := copy(sectstr,succ(obpos),pred(cbpos-obpos));}
end;

function tinifile.new_sect(begval, endval : integer) : pointer;
begin
  fCurSectRec.begno := begval;
  fCurSectRec.endno := endval;
  result := pointer(fCurSectRec);
end;


procedure tinifile.sectnos(noptr  : pointer; var begval, endval : integer);

begin
  CurSectRec := sectcntrec(noptr);
  endval  := CurSectRec.EndNo ;
  begval  := CurSectRec.BegNo ;
end;


procedure tinifile.setnullcursect;

begin
    fcursectindex := -1;
    fcursectname := '[]';
    fillchar(fCurSectRec, sizeof(sectcntrec),0);
end;

procedure tinifile.setnullcurline;

begin
       fcurlinename := '';
       fcurlineindex := -1;
end;

function tinifile.sect_exist(sname : string) : boolean;

var
  bn, en, lc,mc : integer;

begin
  result := false;
  if null_test(sname) or comment_test(sname) or (sname = '[]') then begin
    setnullcursect;
    exit;
  end;
  if not(sect_test(sname)) then sname := opensq+sname+closesq;
  if (uppercase(sname) = uppercase(fcursectname)) then begin
    result := true;
    sectnos(sectlist[fcursectindex], bn, en);
    fcurlinename := '';
    exit;
  end
  else begin
     mc := pred(sectlist.count);
     lc := 0;
     while ((lc <= mc) and not(result)) do begin
        sectnos(sectlist[lc], bn, en);
        if (comparetext(flist[bn], sname) = 0) then begin
           result := true;
           fcursectindex := lc;
           fcursectname := sname;
           sectnos(sectlist[lc], bn, en);
           fcurlinename := '';
           exit;
        end;
        inc(lc);
     end;
   end;
   if not(result) then begin
       setnullcursect;
   end;
end;

function  tinifile.get_line( sname : string; lno : integer) : string;
var
  lc : integer;

begin
     if sect_exist(sname) then begin
        lc := succ(CurSectRec.BegNo+lno);
        result := flist[lc];
        fcurlinename := result;
        fcurlineindex := lc;
     end
     else begin
       result := '';
       setnullcurline;
     end;
end;

function tinifile.get_index( sname, lname : string) : integer;
var
  lc : integer;
  found : boolean;

begin
     result := -1;
     if null_test(lname) or comment_test(lname) then begin
       setnullcurline;
       exit;
     end;
     if sect_exist(sname) then begin
        lc := succ(CurSectRec.BegNo);
        if (comparetext(lname, fcurlinename) = 0) then result := fcurlineindex
        else begin
           found := false;
           while ((lc <= CurSectRec.EndNo) and not(found)) do begin
             if (comparetext(flist[lc], lname) = 0) then begin
               result := lc;
               found := true;
               fcurlinename := lname;
               fcurlineindex := lc;
             end
             else inc(lc);
           end;
           if Not(found) then begin
              setnullcurline;
           end;
        end;
     end
     else begin
       setnullcurline;
     end;
end;

function tinifile.has_value( instr : string; var ostr, vstr : string) : boolean;
var
  tmpstr : string;
  lp, mc : integer;

begin
    result := false;
    ostr := '';
    vstr := '';
    if null_test(instr) or comment_test(instr) then exit;
    if not(sect_test(instr)) then begin
       tmpstr := instr;
       lp := Pos(eqstr, tmpstr);
       mc := length(tmpstr);
       result :=  lp <> 0;
       if result then begin
         ostr := copy(tmpstr,1,pred(lp));
         vstr := copy(tmpstr,succ(lp), (mc-lp));
       end
       else begin
         ostr := tmpstr;
       end;
    end;
end;

procedure tinifile.add_section( sname : string; beg, num : integer);

begin
  if null_test(sname) or comment_test(sname) then exit;
  fcursectindex := sectlist.add(new_sect(beg, num));
  if not(sect_test(sname)) then sname := opensq+sname+closesq;
  if (flist[beg] <> sname) then flist[beg] := sname;
  fcursectname := sname;
  fmodified := true;
end;

{procedure tinifile.change_section( sectno, begdelta, cntdelta : integer);

var
  lc, mc : integer;

begin
   mc := pred(sectlist.count);
   if (sectno = -1) or (sectno > mc) then exit;
   if (sectno <> fcursectindex) then begin
     sectnos(sectlist[sectno], lc , mc);
     fcursectname := flist[lc];
     fcursectindex := sectno;
   end;
   sectlist[sectno] := new_sect(fCurSectRec.BegNo+ begdelta, fCurSectRec.EndNo+ cntdelta);
   fmodified := true;
end;
}


procedure tinifile.renumber;
var
  bscnt,lc,mc : integer;
  sectd : boolean;
  tmpstr : string;

begin
  mc := pred(flist.count);
  sectd := false;
  sectlist.clear;
  bscnt := 0;
  for lc := 0 to mc do begin
     tmpstr := flist[lc];
     if sect_test(tmpstr) then begin
       if sectd then add_section( flist[bscnt], bscnt, pred(lc));
       bscnt := lc;
       sectd := true;
     end;
  end;
  if sectd and (mc >= bscnt) then add_section( flist[bscnt], bscnt, mc);
  setnullcursect;
  fExistingFile := true;
end;

procedure tinifile.remove_empty;
var
  lc,mc : integer;
  tmpstr,tstr2,tstr3 : string;

begin
  lc := 0;
  mc := pred(flist.count);
  while (lc <= mc) do begin
      tmpstr := flist[lc];
      if not(null_test(tmpstr)) then begin
         flist.objects[lc] := nil;
         if has_value( tmpstr, tstr3, tstr2) then begin
            flist.objects[lc] := new_val_obj(tstr2);
         end;
{         else }
         if (tstr3 <> '') then flist[lc] := tstr3
                          else  flist[lc] := tmpstr;
         inc(lc);
      end
      else begin
           free_val_obj(flist.objects[lc]);
           flist.delete(lc);
           mc := pred(flist.count);
      end;
  end;
end;

PROCEDURE tinifile.Flush;

begin
   savefile;
   refresh;
end;

PROCEDURE tinifile.refresh;

begin
   resetfile;
   readfile;
end;


procedure tinifile.readfile;

begin
  fExistingFile := fileexists(fname);
  if not(fExistingFile) then exit;
  flist.loadfromfile(fname);
  remove_empty;
  renumber;
  fmodified := false;
end;

constructor tinifile.Create(afname : tfilename);

begin
  inherited create;
  flist := tstringlist.create;
  with flist do begin
      sorted := false;
      duplicates := dupaccept;
      clear;
  end;
  fSectionNameList := tstringlist.Create;
  with fSectionNameList do begin
      sorted := true;
  end;
  fsectlist := tlist.create;
  fname := afname;
  setnullcurline;
  readfile;
end;

procedure tinifile.resetfile;
var
  mc, lc : integer;

begin
   mc := pred(flist.count);
   for lc := 0 to mc do free_val_obj(flist.objects[lc]);
   flist.clear;
   renumber;
end;

procedure tinifile.savefile;
var
  mc, lc : integer;
  vstr, tmpstr : string;

begin
  if fmodified then begin
    mc := pred(flist.count);
    lc := 0;
    while (lc <= mc) do begin
     tmpstr := flist[lc];
     vstr := show_val(flist.objects[lc]);
     free_val_obj(flist.objects[lc]);
     flist.objects[lc] := nil;
     if sect_test( tmpstr) then begin
         flist.insert(lc, '');
         inc(lc,2);
         mc := pred(flist.count);
     end
     else begin
       if (not(null_test(tmpstr)) and not(COMMENT_test(vstr))) then begin
        if not(null_test(vstr)) then flist[lc] := concat(tmpstr,eqstr,vstr)
                                else flist[lc] := tmpstr;
        inc(lc);
       end
       else begin
         if null_test(tmpstr) then begin
           free_val_obj(flist.objects[lc]);
           flist.delete(lc);
           mc := pred(flist.count);
         end
         else inc(lc);
       end;
     end;
    end;
    deletefile(fname);
    flist.savetofile(fname);
  end;
end;

destructor tinifile.Destroy;

begin
  savefile;
  flist.free;
  fsectlist.free;
  fSectionNameList.free;
  inherited destroy;
end;

function tinifile.IsBoolean( valstr : string; var val : boolean) : Boolean;
var
  tr, fl : boolean;
  tmpstr : string;

begin
   tr  := false;
   fl := false;
   result := false;
   tmpstr := erase_white(valstr);
   if null_test(tmpstr) then exit;
   if ((comparetext(tmpstr, truestr) = 0) or (comparetext(tmpstr, 'T') = 0) or (comparetext(tmpstr, 'Yes') = 0)
      or (comparetext(tmpstr, 'Y')  = 0) or (comparetext(tmpstr, '1') = 0)) then tr := true;
   if ((comparetext(tmpstr,Falsestr)=0) or (comparetext(tmpstr,'F') = 0) or (comparetext(tmpstr,'No') = 0)
      or (comparetext(tmpstr, 'N')  = 0) or (comparetext(tmpstr, '0') = 0)) then fl := true;
   result := tr or fl;
   val := tr;
end;

function tinifile.IsInteger( valstr : string; var val : LongInt) : Boolean;
begin
 {  valstr := erase_white(valstr);}
   result := false{pos(stopstr, valstr) = 0};
   val := -1;
   if null_test(valstr) then exit;
{   if result then begin}
       try
           val := strtoint(erase_white(valstr));
           result := true;
       except
{          result := false;}
       end;
{   end;}
end;

function tinifile.IsDouble( valstr : string; var val : Double) : Boolean;
begin
{   valstr := erase_white(valstr);}
   result := false;{pos(stopstr, valstr) <> 0;}
   val := -1.0;
   if null_test(valstr) then exit;
{   if result then begin}
       try
           val := strtofloat(erase_white(valstr));
           result := true;
       except
{          result := false;}
       end;
{   end;}
end;

function tinifile.IsString( valstr : string; var val : String) : Boolean;
{var
  db : boolean;
  di : longint;
  dii : integer;
  dd : double;
  dp : pointer;
  ds : string;}

begin
{   val := '';}
   result := true;
   {((valstr <> '') or (isboolean(valstr,db) or isinteger(valstr, di)
               or isdouble(valstr, dd) or ispointer(valstr, ds, dii ,dp)))}
{   if result then}
    val := valstr;
end;

function tinifile.IsPointer( valstr : string; var pstr : string; var size : integer; var val : Pointer) : Boolean;

begin
   result := pos(sepchar, erase_white(valstr)) <> 0;
{   val := valstr;}
end;


function tinifile.ReadBool(const Section, Ident: string; Default: Boolean): Boolean;
var
  nd : integer;
  db : boolean;

begin
   nd := get_index( section, Ident);
   if (nd <> -1) then begin
       if isboolean(show_val(flist.objects[nd]),db) then result := db
                                         else result := default;
   end
   else result := default;
end;

function tinifile.ReadInteger(const Section, Ident: string; Default: Longint): Longint;
var
  nd : integer;
  db : longint;

begin
   nd := get_index( section, Ident);
   if (nd <> -1) then begin
       if isinteger(show_val(flist.objects[nd]),db) then result := db
                                         else result := default;
   end
   else result := default;
end;

function tinifile.ReadDouble(const Section, Ident: string; Default: Double): Double;
var
  di : longint;
  nd : integer;
  db : double;

begin
   nd := get_index( section, Ident);
   if (nd <> -1) then begin
       if isdouble(show_val(flist.objects[nd]),db) then result := db
                                         else if isinteger(show_val(flist.objects[nd]),di) then result := di
                                              else result := default;
   end
   else result := default;
end;

function tinifile.ReadString(const Section, Ident, Default: string): string;
var
  nd : integer;
  db : string;

begin
   nd := get_index( section, Ident);
   if (nd <> -1) then begin
       if isstring(show_val(flist.objects[nd]),db) then result := db
                                         else result := default;
   end
   else result := default;
end;

function parse_structstr(astr : string; aplist : tstringlist) : integer;
var
  sl, lc, mc : integer;
  tstr : string;

begin
   result := 0;
   if null_test(astr) then exit;
   Split_linestr(astr, ',', aplist);
   mc := pred(aplist.count);
   for lc := 0 to mc do begin
     tstr := aplist[lc];
     case tstr[1] of
         'S' : begin
                 sl := length(tstr);
                 tstr := copy(tstr, 2, pred(sl));
                 sl := strtoint(tstr)+1;
                 {if sl > 250 then begin
                    sl := 250;
                    aplist[lc] := 'S'+inttostr(sl-1);
                 end;}
                 inc(result, sl);
               end;
         'B' : begin
                  inc(result, sizeof(boolean));
               end;
         'F' : begin
                  inc(result, sizeof(tfloat));
               end;
         'I' : begin
                  inc(result, sizeof(longint));
               end;
     end;
   end;
end;

function tinifile.ReadPointer(const Section, Ident: string; structstr : string): Pointer;
var
  tstr : string;

begin
   result := nil;
   tstr := readstring(Section, Ident, '');
   if null_test(tstr) then exit;
   result := ReadString2Pointer(tstr, structstr);
end;

function tinifile.ReadString2Pointer(tstr : string; structstr : string): Pointer;
var
  aplist, slist : tstringlist;
  ssl, lsl, ppos, ss,  lc,lc2, mc : integer;
  sl : byte;
  sstr : string;
  abytearray : pbytearray;
  tb : boolean;
  tf : double;
  ti : longint;

begin
   result := nil;
   aplist := tstringlist.create;
   slist := tstringlist.create;
   Split_linestr(tstr, ',', aplist);
{   Split_line(structstr, ',', slist);}
   ss := parse_structstr(structstr, slist);
   if aplist.count <> slist.count then begin
       showmessage('structure different to ini file');
       exit;
   end;
   getmem(result, ss);
   fillchar(result^, ss, #0);
   abytearray := pbytearray(result);
   mc := pred(aplist.count);
   ppos := 0;
   for lc := 0 to mc do begin
     sstr := slist[lc];
     tstr := aplist[lc];
     case sstr[1] of
         'S' : begin
                 sl := length(Sstr);
                 sstr := copy(sstr, 2, pred(sl));
                 ssl := strtoint(Sstr);
                 sl := length(Tstr);
                 if (sl > ssl) then begin
                   tstr := copy(tstr, 1, ssl);
                   sl := ssl;
                 end;
                 for lc2 := 1 to sl do char(abytearray^[ppos+lc2]) := tstr[lc2];
                 move(sl,  abytearray^[ppos],1);
                 inc(ppos, succ(ssl));
               end;
         'B' : begin
                  lsl := sizeof(boolean);
                  if isboolean(erase_white(tstr), tb) then move(tb, abytearray^[ppos], lsl);
                  {abytearray^[ppos] := byte(tb);}
                  inc(ppos, lsl);
               end;
         'F' : begin
                  lsl := sizeof(tfloat);
                  if isdouble(erase_white(tstr), tf) then move(tf, abytearray^[ppos], lsl);
                  inc(ppos, lsl);
               end;
         'I' : begin
                  lsl := sizeof(longint);
                  if isinteger(erase_white(tstr), ti) then move(ti, abytearray^[ppos], lsl);
                  inc(ppos, lsl);
               end;
     end;
   end;
   aplist.free;
   slist.free;

end;


procedure tinifile.EraseSection(const Section: string);
var
  cnt : integer;

begin
   if null_test(section)then exit;
   if sect_exist(section) then begin
     for cnt := CurSectRec.eNDNo DOWNto CurSectRec.BEGNo do begin
       free_val_obj(flist.objects[cnt]);
       flist.delete(cnt);
     end;
     renumber;
     fmodified := true;
{     fcursectname := '[]';
     fillchar(CurSectRec, sizeof(sectcntrec),0);
     fcursectindex := -1;}
   end;
end;

procedure tinifile.ExchangeSection(const Section: string; aplist : tstrings);
var
  tc, xc, mc, rc, cnt : integer;

begin
   mc := pred(aplist.count);
   if null_test(section) then exit;
   if sect_exist(section) then begin
      with CurSectRec do rc := pred(EndNo - BegNo);
      xc := lessint(rc, mc);
      for cnt := 0 to xc do begin
        tc := succ(CurSectRec.BegNo)+cnt;
        flist[tc] := aplist[cnt];
      end;
      if mc > rc then for cnt := xc to mc do writestring(section, aplist[cnt], '');
      if mc < rc then begin
         for cnt := rc downto xc do begin
           tc := succ(CurSectRec.BegNo)+xc;
           free_val_obj(flist.objects[tc]);
           flist.delete(tc);
         end;
{             sectlist[fcursectindex] := new_sect(fCurSectRec.BegNo, CurSectRec.BegNo+xc+1);}
         renumber;
      end;
   end
   else begin
         for cnt := 0 to mc do WriteString(section,aplist[cnt], '');
   end;
end;


procedure tinifile.ReadSection (const Section: string; AStrings: TStrings);
var
  cnt : integer;
  astr : string;

begin
   if null_test(section) then exit;
   if sect_exist(section) then with CurSectRec do begin
     for cnt := succ(BegNo) to EndNo do begin
       astr := flist[cnt];
       AStrings.add(astr);
     end;
   end;
end;

procedure tinifile.ReadWholeSection (const Section: string; AStrings: TStrings);
var
  cnt : integer;
  vstr, tmpstr, addstr : string;

begin
   if null_test(section) then exit;
   if sect_exist(section) then with CurSectRec do begin
     for cnt := succ(BegNo) to EndNo do begin
       tmpstr := flist[cnt];
       vstr := show_val(flist.objects[cnt]);
        if not(null_test(vstr)) then addstr := concat(tmpstr,eqstr,vstr)
                                else addstr := tmpstr;
       AStrings.add(addstr);
     end;
   end;
end;

function tinifile.ReadWholeSectionAsString (const Section: string ): string;
var
  cnt : integer;
  vstr, tmpstr, addstr : string;

begin
   if null_test(section) then exit;
   if sect_exist(section) then with CurSectRec do begin
     result := '';
     for cnt := succ(BegNo) to EndNo do begin
       tmpstr := flist[cnt];
       vstr := show_val(flist.objects[cnt]);
       if not(null_test(vstr)) then addstr := concat(tmpstr,eqstr,vstr)
       else begin
           if cnt > succ(BegNo) then addstr := ' '+tmpstr
                                else addstr := tmpstr;
       end;
       result := result + addstr;
     end;
   end;
end;



procedure tinifile.ReadSectionValues(const Section: string; AStrings: TStrings);
var
  cnt : integer;
  tmpstr : string;

begin
   if null_test(section) then exit;
   if sect_exist(section) then with CurSectRec do begin
     for cnt := succ(BegNo) to EndNo do begin
       tmpstr := flist[cnt];
       AStrings.add(tmpstr+'='+show_val(flist.objects[cnt]));
{       AStrings.values[tmpstr] := show_val(flist.objects[cnt]);}
     end;
   end;
end;

function booltostr( val : boolean) : string;

begin
    if val then result := 'True'
           else result := 'False';
end;


procedure tinifile.WriteBool(const Section, Ident: string; Value: Boolean);

begin
     writestring(Section, Ident, booltostr(value));
end;

procedure tinifile.WriteInteger(const Section, Ident: string; Value: Longint);

begin
     writestring(section, Ident, inttostr(value));
end;

procedure tinifile.WriteString(const Section, Ident, Value: string);
var
  nd : integer;
  cnt : integer;
  tmpstr : string;

begin
   if null_test(section) OR nULL_TEST(ident) then exit;
    nd := get_index( section, Ident);
    if (nd <> -1) then begin
      if (value <> show_val(flist.objects[nd])) then begin
        free_val_obj(flist.objects[nd]);
        flist.objects[nd] := new_val_obj(value);
        fmodified := true;
      end;
    end
    else begin
      if sect_exist(section) then begin
        cnt := succ(CurSectRec.BegNo);
        flist.insert(cnt, ident);
      end
      else if (not(null_test(section)) and not(null_test(ident))) then begin
        tmpstr := section;
        if not(sect_test(tmpstr)) then tmpstr := opensq+section+closesq;
        cnt := flist.add( tmpstr);
        cnt := flist.add( ident);
      end
      else exit;
      flist.objects[cnt] := new_val_obj(value);
      renumber;
   end;
end;

procedure tinifile.Erase_line(const Section, Ident: string);
var
  nd : integer;

begin
    if null_test(section) OR nULL_TEST(ident) then exit;
    nd := get_index( section, Ident);
    if (nd <> -1) then begin
      free_val_obj(flist.objects[nd]);
      flist.delete(nd);
      renumber;
    end;
end;


procedure tinifile.WriteDouble(const Section, Ident: string; Value: Double);

begin
   writestring(section, Ident, floattostr(value));
end;

procedure tinifile.WritePointer(const Section, Ident: string; structstr : string; Value: Pointer);
var
  slist : tstringlist;
  ssl, lsl, ppos, ss, sl, lc, mc : integer;
  sep, lstr, sstr, tstr : string;
  abytearray : pbytearray;
  tb : boolean;
  tf : double;
  ti : longint;

begin
   if (value = nil) then exit;
   slist := tstringlist.create;
   ss := parse_structstr(structstr, slist);
   abytearray := pbytearray(VALUE);
   tstr := '';
   sep := '';
   ppos := 0;
   mc := pred(slist.count);
   for lc := 0 to mc do begin
     sstr := slist[lc];
     case sstr[1] of
         'S' : begin
                 sl := length(sstr);
                 sstr := copy(sstr, 2, pred(sl));
                 ssl := strtoint(sstr)+1;
                 move(abytearray^[ppos], lstr,  ssl);
                 tstr := tstr+sep+lstr;
                 inc(ppos, ssl);
               end;
         'B' : begin
                  lsl := sizeof(boolean);
                  move(abytearray^[ppos], tb, lsl);
                  tstr := tstr+sep+booltostr(tb);
                  inc(ppos, lsl);
               end;
         'F' : begin
                  lsl := sizeof(tfloat);
                  move(abytearray^[ppos], tf, lsl);
                  tstr := tstr+sep+floattostr(tf);
                  inc(ppos, lsl);
               end;
         'I' : begin
                  lsl := sizeof(longint);
                  move(abytearray^[ppos], ti, lsl);
                  tstr := tstr+sep+inttostr(ti);
                  inc(ppos, lsl);
               end;
     end;
     sep := ',';
   end;
   slist.free;
   writestring(section, Ident, tstr);
end;

Function tinifile.GetSectionNameList : tstringlist;
Var
   bn, en,lc, mc : integer;
   tstr : string;

Begin
   fSectionNameList.clear;
   mc := pred(sectlist.count);
   for lc := 0 to mc do begin
        sectnos(sectlist[lc], bn, en);
        tstr := flist[bn];
        tstr:=remove_char(opensq,tstr);
        tstr:=remove_char(closesq,tstr);
        fSectionNameList.add(tstr);
   end;
   Result := fSectionNameList;
End;

PROCEDURE tinifile.writefont(const Section, Ident: string; afont : tfont);
var
   afontstruc : tfontstruc;

begin
   with afontstruc, afont do begin
     fontstrucName := name;
     fontstrucSize := size;
     fontstrucColor := colortostring(color);
     if fsbold in Style then fontstrucBold :=true
                        else fontstrucBold :=false;
     if fsItalic in Style then fontstrucItalic :=true
                        else fontstrucItalic :=false;
     if fsUnderline in Style then fontstrucUnderline :=true
                        else fontstrucUnderline :=false;
     if fsStrikeOut in Style then fontstrucStrikeOut :=true
                        else fontstrucStrikeOut :=false;
   end;
   writepointer(Section, Ident, fontstrucstr, @afontstruc);
end;

PROCEDURE tinifile.readfont(const Section, Ident: string; afont: tfont);

var
   apfontstruc : ^tfontstruc;

begin
   apfontstruc := readpointer(Section, Ident, fontstrucstr);
   if (apfontstruc <> nil) then with apfontstruc^, afont do begin
     Name := fontstrucname;
     Size :=  fontstrucsize;
     Color := stringtocolor(fontstruccolor);
     Style := [];
     if  fontstrucBold then Style := Style+[fsbold];
     if  fontstrucItalic then Style := Style+[fsItalic];
     if  fontstrucUnderline then Style := Style+[fsUnderline];
     if  fontstrucStrikeOut then Style := Style+[fsStrikeOut];
     freemem(apfontstruc, sizeof(tfontstruc));
   end;
end;

PROCEDURE tinifile.writeform(aform : tform);

begin
   With aform do begin
     WriteInteger(Caption, Ini_WLeft  , Left);
     WriteInteger(Caption, Ini_WTop   , Top);
     WriteInteger(Caption, Ini_WWidth , Width);
     WriteInteger(Caption, Ini_WHeight, Height);
   end;
end;

procedure rescaleform(aform : tform);

begin
   With aform do begin
      if (tag = 0) then begin
        scaleby(designscale,runscale);
        pixelsperinch := runscale;
        tag := 1;
      end;
   end;

end;


PROCEDURE tinifile.readform(aform : tform);
begin
   With aform do begin
      rescaleform(aform);
      Left := ReadInteger(Caption, Ini_WLeft, Left);
      Top := ReadInteger(Caption, Ini_WTop, top);
      Width := ReadInteger(Caption, Ini_WWidth, width);
      Height := ReadInteger(Caption, Ini_WHeight, height);
   end;
end;

function tinifile.SectionCount(const Section: string): Longint;

begin
   result := -1;
   if null_test(section) then exit;
   if sect_exist(section) then with CurSectRec do result := (EndNo - succ(BegNo));
end;

procedure tinifile.ReadStringList(const Section, Ident : string; AStrings: TStrings);
Var
   tstr : string;

begin
   AStrings.clear;
   tstr := readstring(Section, Ident, '');
   if null_test(tstr) then exit;
   Split_linestr(tstr, ',', AStrings);
end;

procedure tinifile.WriteStringList(const Section, Ident : string; AStrings: TStrings);
Var
   lc, mc : integer;
   tstr : string;

Begin
   mc := pred(AStrings.count);
   tstr := '';
   for lc := 0 to mc do begin
        if (lc > 0) then tstr := tstr+',';
        tstr := tstr+AStrings[lc];
   end;
   writestring(Section, Ident, tstr);
end;


initialization
      runscale := screen.pixelsperinch;
      inifile := nil;
end.


